package com.kccoder.fracture.example;

import com.kccoder.fracture.Fracture;
import com.kccoder.fracture.IProcessor;
import com.kccoder.fracture.util.MethodTimer;

public class PrimeExample {
	private static final int START = 11235813;
	private static final int END =   13235813;
	
	public static void main(String[] args) throws Exception {
		MethodTimer.compareMethods(PrimeExample.class, "normalWay", "fractureWay");
	}
	
	public static void normalWay() {
		for(int i = START; i < END; i+=2) {
			isPrime(i);
		}
	}	
	
	public static void fractureWay() {
		Fracture.forEach(START, END, 2, new IProcessor<Integer>() {
			public void processElement(Integer i) {
				isPrime(i);
			}			
		});
	}
	
	public static boolean isPrime(int n) {
		int sqrt = (int)Math.sqrt(n);
		for(int i = 2; i <= sqrt; i++) {
			if (n%i == 0) {
				return false;
			}
		}
		return true;
	}
}