package com.kccoder.fracture.util;

import java.lang.reflect.Method;

public class MethodTimer {
	public static long time(Object object, String methodName, Object...params) throws Exception {
		return time(object.getClass(), object, methodName, params);
	}
	
	public static long time(Class clazz, String methodName, Object...params) throws Exception {
		return time(clazz, null, methodName, params);
	}
			
	public static long time(Class clazz, Object object, String methodName, Object...params) throws Exception {
		Method method = clazz.getMethod(methodName);
		long s = System.currentTimeMillis();
		method.invoke(object);
		long t = System.currentTimeMillis() - s;
		System.out.println("Method [" + clazz.getName() + "." + methodName + "] took [" + t + "] millis to complete");
		return t;
	}
	
	public static void compareMethods(Class clazz, String method1, String method2) throws Exception {
//		Class clazz = getCallingClass();
		long t1 = MethodTimer.time(clazz, method1);
		long t2 = MethodTimer.time(clazz, method2);
		double d = ((double)t1)/((double)t2);
		System.out.println(method2 + " executed [" + d + "] times faster than " + method1);
	}
}